﻿@using LoyaltyPointEngine.Common
@model LoyaltyPointEngine.Model.Parameter.Receipt.UploadReceiptCMSModel
@{
    int detailindex = 0;
    List<SelectListItem> channelList = (List<SelectListItem>)ViewBag.ChannelList;
    List<SelectListItem> rejectReasonList = SiteSetting.ReceiptRejectReasonList.Select(x => new SelectListItem() { Text = x.Value, Value = x.Value }).ToList();
    List<SelectListItem> IsOnlineList = new List<SelectListItem>();
    IsOnlineList.Add(new SelectListItem { Text = "Offline", Value = "False" });
    IsOnlineList.Add(new SelectListItem { Text = "Online", Value = "True" });
}
<!--=== Page Content ===-->
<div class="row">
    <div class="col-md-12">
        <h5 class="widget-title"><i class="icon-sign-blank"></i>Moderate Receipt</h5>
    </div>
</div>
@using (Html.BeginForm(MVC.Receipt.Moderate(), FormMethod.Post, new { enctype = "multipart/form-data", @class = "form-horizontal row-border", @id = "formAddReceipt" }))
{
    <div class="row">
        <!--=== Validation Example 1 ===-->
        <div class="col-md-12">
            <div class="widget box">
                <div class="widget-header">
                    <h4><i class="icon-reorder"></i>Receipt Header</h4>
                </div>
                <div class="widget-content">
                    @Html.AntiForgeryToken()
                    @Html.HiddenFor(x => x.Code)

                    @if (!Html.ViewData.ModelState.IsValid)
                    {
                        <div class="alert alert-danger">
                            <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                            <i class="fa fa-times-circle"></i>
                            Error occured:
                            <br />
                            @Html.ValidationSummary()
                        </div>
                    }
                    @Html.HiddenFor(x => x.ID)
                    <div class="form-group">
                        <label class="col-md-3 control-label">Member <span class="required">*</span></label>
                        <div class="col-md-6">
                            @Html.HiddenFor(x => x.MemberID)
                            @Html.TextBoxFor(x => x.MemberName, new { @class = "form-control", @readonly = "", @required = "" })
                        </div>
                        <button type="button" class="col-md-3 btn btn-primary" data-toggle="modal" data-target="#memberModal" data-whatever="lala">Select Member</button>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Code <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Model.Code
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Kode Event </label>
                        <div class="col-md-9">
                            @Model.EventCode
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Receipt Code </label>
                        <div class="col-md-9">
                            @Html.Hidden("ReceiptCodeHidden", Model.ReceiptCode)
                            @Html.TextBoxFor(x => x.ReceiptCode, new { @class = "form-control", })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Retailer <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.DropDownListFor(x => x.RetailerID, ViewBag.ListRetailer as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @required = "required" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Retailer Address <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextAreaFor(x => x.RetailerAddress, new { @class = "form-control", @required = "" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Retailer Post Code</label>
                        <div class="col-md-9">
                            @Html.TextAreaFor(x => x.RetailerPostCode, new { @class = "form-control" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Transaction Date <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.StrTransactionDate, new { @class = "form-control datepicker" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Transaction Time <span class="required">*</span></label>
                        <div class="col-md-3">
                            <input type="text" id="StrTransactionTime" name="StrTransactionTime" class="form-control" data-mask="99:99:99" value="@Model.StrTransactionTime"><span class="help-block">HH:MM:SS</span>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Request Date</label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.StrRequestDate, new { @class = "form-control datepicker" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Campaign</label>
                        <div class="col-md-3">
                            @Html.DropDownListFor(x => x.CampaignID, ViewBag.ListCampaign as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Channel <span class="required">*</span></label>
                        <div class="col-md-3">
                            @Html.DropDownListFor(x => x.Channel, channelList, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @required = "required", disabled = "disabled" })
                            <input type="hidden" name="hdnChannel" value="@Model.Channel" />
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Total Price <span class="required">*</span> </label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.TotalPrice, new { @class = "form-control", @required = "required" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Receipt Type <span class="required">*</span></label>
                        <div class="col-md-3">
                            @Html.DropDownListFor(x => x.IsOnline, IsOnlineList, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @required = "required", disabled = "disabled" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Image</label>
                        <div class="col-md-9">
                            <div class="slickiiii">
                                @if (Model.Image != null && Model.Image.Count() > 0)
                                {
                                    string imageHost = Settings.GetValueByKey(LoyaltyPointEngine.Common.SiteSetting.ASSET_URL);
                                    foreach (string imageurl in Model.Image)
                                    {
                                        string imagefullUrl = imageHost + imageurl;
                                        <a href="#" onclick="readURL('@imagefullUrl')" data-toggle="modal" data-target="#imageViewer">
                                            <div class="item">
                                                <img src="@imagefullUrl" alt="">
                                            </div>
                                        </a>
                                    }
                                }
                            </div>
                        </div>
                    </div>
                    <input id="TotalAction" name="TotalAction" type="hidden" value="@Model.ReceiptDetails.Count()">
                    <div style="display: none">
                        @Html.DropDownListFor(x => x.ActionDummy, ViewBag.ListAction as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix" })
                    </div>
                </div>
            </div>
            <!-- /Validation Example 1 -->
        </div>
    </div>

    foreach (LoyaltyPointEngine.Model.Parameter.Receipt.UploadReceiptDetailCMSModel detail in Model.ReceiptDetails)
    {
        detailindex++;
        int quantityApproved = detail.QuantityApproved == 0 ? detail.Quantity : detail.QuantityApproved;
        int totalpoint = detail.Points * quantityApproved;
        <div id="action-box">
            <div class="row action-obj-@detailindex">
                <div class="col-md-12">
                    <div class="widget box">
                        <div class="widget-header">
                            <h4><i class="icon-reorder"></i>Receipt Detail</h4>
                            @if (detailindex > 1)
                            {
                    <!-- Toolbar -->
                                <div class="toolbar no-padding">
                                    <div class="btn-group" onclick="removeAction(@detailindex)">
                                        <span class="btn btn-xs"><i class="icon-minus"></i>Remove</span>
                                    </div>
                                </div>
                    <!-- /Toolbar -->
                            }
                        </div>
                        <div class="widget-content">
                            <div class="form-group">
                                <label class="col-md-3 control-label">Action <span class="required">*</span></label>
                                <div class="col-md-9">
                                    <select id="ActionID-@detailindex" name="ActionID-@detailindex" class="select2-select-00 col-md-12 full-width-fix actionId-check" onchange="GetActionValue(this.value, @detailindex)" required>
                                        <option></option>
                                        @foreach (SelectListItem item in ViewBag.ListAction)
                                        {
                                            string selected = (detail.ActionID.ToString() == item.Value) ? "selected" : string.Empty;
                                            <option value="@item.Value" @selected>@item.Text</option>
                                        }
                                    </select>
                                </div>
                            </div>
                            @if (detail.ChildID.HasValue)
                            {
                                <div class="form-group">
                                    <label class="col-md-3 control-label">Child</label>
                                    <div class="col-md-9">
                                        <input class="form-control" type="text" readonly value="@detail.ChildName" />
                                        <input type="hidden" id="ChildID-@detailindex" name="ChildID-@detailindex" value="@detail.ChildID" />
                                    </div>
                                </div>
                            }
                            <div class="form-group">
                                <label class="col-md-3 control-label">Quantity <span class="required">*</span></label>
                                <div class="col-md-9">
                                    <input class="form-control ipt-number" id="Quantity-@detailindex" name="Quantity-@detailindex" onchange="SetTotalPoint(this.value, @detailindex)" required value="@detail.Quantity" type="tel">
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Points</label>
                                <div class="col-md-9">
                                    <input class="form-control ipt-number" id="Points-@detailindex" name="Points-@detailindex" readonly="" value="@detail.Points" type="tel">
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Quantity Approved</label>
                                <div class="col-md-9">
                                    <input class="form-control ipt-number quantity-check" id="QuantityApproved-@detailindex" name="QuantityApproved-@detailindex" onchange="SetTotalQuantityPoint(this.value, @detailindex)" value="@detail.QuantityApproved" type="tel" required>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Item Price <span class="required">*</span></label>
                                <div class="col-md-9">
                                    <input class="form-control ipt-number price-check" id="ItemPrice-@detailindex" name="ItemPrice-@detailindex" value="@detail.ItemPrice" type="tel" min="1" required />
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Total Quantity Approved Points</label>
                                <div class="col-md-9">
                                    <input class="form-control TotalQuantityApproved ipt-number" id="TotalQuantityApprovedPoints-@detailindex" name="TotalQuantityApprovedPoints-@detailindex" readonly="" value="@totalpoint" type="tel">
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-md-3 control-label">Remarks</label>
                                <div class="col-md-9">
                                    <textarea class="form-control" id="Remarks-@detailindex" name="Remarks-@detailindex">@detail.Remarks</textarea>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    }
    <div class="row">
        <div class="col-md-12 ta-center">
            <div class="col-md-3">
                <a href="javascript:void(0)" onclick="addAction()" class="btn button big red"><span class="glyphicon additional plus margin-right-10"></span>Add More Detail</a>
            </div>
            <label class="col-md-2 control-label">Total All </label>
            <div class="col-md-2">
                <input class="form-control" id="TotalAllPoint" name="TotalAllPoint" type="text" value="0" readonly>
            </div>
            <div class="col-md-2">
                <input type="submit" value="Submit" class="btn btn-primary pull-right">
            </div>
            <div class="col-md-3">
                <a href="#" data-toggle="modal" data-target="#RejectModal" class="btn btn-danger">Reject Receipt</a>
            </div>
        </div>
    </div>
    <div class="row">
        <br />
    </div>
}

<div class="modal fade" id="memberModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" style="width: auto !important" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Select Member</h4>
            </div>
            <div class="modal-body">
                @Html.Action("GridGetSelectMemberPager", "Member", new { page = 1 })
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="imageViewer" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">View Image</h4>
            </div>
            <div class="modal-body">
                <div>
                    <img id="blah" src="#" alt="your image" />
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="RejectModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Form Reject Receipt</h4>
            </div>
            @using (Html.BeginForm(MVC.Receipt.Reject(), FormMethod.Post, new { enctype = "multipart/form-data", @class = "form-horizontal row-border", @id = "formRejectReceipt" }))
            {
                <div class="modal-body">
                    <div>
                        <div class="row">
                            <!--=== Validation Example 1 ===-->
                            <div class="col-md-12">
                                <div class="widget box">
                                    <div class="widget-content">
                                        <div class="form-group">
                                            <label class="col-md-3 control-label">Reason <span class="required">*</span></label>
                                            <div class="col-md-9">
                                                @Html.HiddenFor(x => x.ID)
                                                @*<textarea id="Reason" name="Reason" class="form-control" required>@Model.RejectReason</textarea>*@
                                                @Html.DropDownList("Reason", rejectReasonList, "", new { @class = "form-control" })
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <label class="col-md-3 control-label">Is Need Reupload: </label>
                                            <div class="col-md-9">
                                                @Html.CheckBoxFor(x => x.IsNeedReuploadData, new { @class = "uniform" })
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!-- /Validation Example 1 -->
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                    <a href="javascript:void(0)" onclick="RejectDocument()" class="btn btn-danger" data-dismiss="modal">Reject Receipt</a>
                </div>
            }
        </div>
    </div>
</div>
@section FooterScript{
    <script type="text/javascript">

    function GetAllTotalPoint() {
        var total = 0;
        $('.TotalQuantityApproved').each(function () {
            total += parseInt(this.value);
        });
        return total;
    }
    function readURL(url) {
        $('#blah').attr('src', url);
    }
    //(function () {
    //    var gridName = 'GridSelectMember';
    //    var pagingUrl = '@Url.Action(MVC.Member.GridGetSelectMemberPager())';
    //
    //    $('.grid-mvc').gridmvc();
    //    pageGrids[gridName].ajaxify({
    //        getData: pagingUrl,
    //        getPagedData: pagingUrl,
    //        gridFilterForm: $('#gridSeachMember')
    //    });
    //}())

    //function ini dipanggil sama popup Member
    function SelectMember(MemberID, MemberName) {
        $('#MemberID').val(MemberID);
        $('#MemberName').val(MemberName);
        $('#memberModal').modal('hide');
    };


    function GetActionValue(val, index) {
        _url = '@Url.Action(MVC.Action.GetActionValueById(999999999))';
        _url = _url.replace("999999999", val);
        $.ajax({
            url: _url,
            timeout: 30000,
            success: function (msg) {
                $('#Points-' + index).val(msg.value);
                $('#QuantityApproved-' + index).val(0);
                $('#TotalQuantityApprovedPoints-' + index).val(msg.value);
                var _TotalPoint = GetAllTotalPoint();
                $('#TotalAllPoint').val(_TotalPoint);
                if (msg.isCampaign)
                    alert("Campaign " + msg.campaignName + " is Active");
            },
            error: function (jqXHR, textStatus) {
                alert('Error Occured'); //MESSAGE
            }
        })
    }

    function SetTotalPoint(val, index) {
        var actionPoint = $('#Points-' + index).val();
        var total = actionPoint * val;
        $('#QuantityApproved-' + index).val(val);
        $('#TotalQuantityApprovedPoints-' + index).val(total);
        var _TotalPoint = GetAllTotalPoint();
        $('#TotalAllPoint').val(_TotalPoint);
    }
    function SetTotalQuantityPoint(val, index) {
        var actionPoint = parseInt($('#Points-' + index).val());
        var quantityVal = parseInt($('#Quantity-' + index).val());


        if (val > quantityVal) {
            alert('Quantity Approved should be less than or equal to Quantity');
            $('#QuantityApproved-' + index).val(quantityVal);
        } else {
            var total = actionPoint * val;
            $('#TotalQuantityApprovedPoints-' + index).val(total);
            var _TotalPoint = GetAllTotalPoint();
            $('#TotalAllPoint').val(_TotalPoint);
        }
    }
    function InitialSlick() {
        $('.slickiiii').slick({
            infinite: false,
            slidesToShow: 2,
            slidesToScroll: 1
        });
    }
    //validation
    $(document).ready(function () {
        InitialSlick()
        //set total all
        var _TotalPoint = GetAllTotalPoint();
        $('#TotalAllPoint').val(_TotalPoint);

        //===== Validation =====//
        //for default options, see assets/js/plugins.form-components.js (initValidation())

        $.extend($.validator.defaults, {
            invalidHandler: function (form, validator) {
                var errors = validator.numberOfInvalids();
                if (errors) {
                    var message = errors == 1
                    ? 'You missed 1 field. It has been highlighted.'
                    : 'You missed ' + errors + ' fields. They have been highlighted.';
                    noty({
                        text: message,
                        type: 'error',
                        timeout: 2000
                    });
                }
            },
            errorPlacement: function (error, element) {
                if (element.attr('type') === "file" && element.data('style') === "fileinput") {
                    error.appendTo(element.closest("div.fileinput-holder").parent('div'));
                } else {
                    error.insertAfter(element)
                }
            }
        });

        $("#formAddRedeem").validate();

        $('input[name=ReceiptCode]').on('blur', function (e) {
            if ($(this).val().length > 3) {
                var currentValue = $('#ReceiptCodeHidden').val();
                if ($(this).val() != currentValue) {
                    $.ajax({
                        type: "post",
                        url: "@Url.Action(MVC.Receipt.CheckDuplicateReceiptCode())",
                            data: { "ReceiptCode": $(this).val() },
                            success: function (data) {
                                if (data != "") {
                                    alert(ParseDom(data));
                                }
                                HideLoader();
                            },
                            error: function (request, status, error) {
                                alert(ParseDom(request.responseText));
                                HideLoader();
                            }
                        })
                    }
                }
            });

            function LoadGridFunctions() {
                function LoadData(dataUrl) {
                    if (dataUrl) {
                        $.ajax({
                            url: dataUrl,
                            complete: function (xhr, status) {
                                if (status === 'success') {
                                    $('div#memberModal .modal-body').html(xhr.responseText);
                                } else {
                                    alert(status + ' : ' + xhr.responseText);
                                }
                                LoadGridFunctions();
                            }
                        })
                    }
                }

                $('#grid-select-member div.grid-header-title > a, #grid-select-member .grid-footer ul.pagination li > a').on('click', function (e) {
                    e.preventDefault();
                    var dataUrl = $(this).data('url');
                    LoadData(dataUrl);
                })

                $('form[name=grid-select-member-form]').on('submit', function (e) {
                    e.preventDefault();
                    //e.stopPropagation();
                    HideLoader();
                    var dataUrl = decodeURIComponent($(this).find('[type=hidden][name=rawDataUrl]').val()).replace('@@search@@', $(this).find('[type=text][name=txtSearch]').val());
                    LoadData(dataUrl);
                })
            }
            LoadGridFunctions();

            $('#formAddReceipt').on('change', '.price-check', function () {
                debugger
                var id = $(this).attr('id');
                var price = $(this).val();
                var actionId = $(this).closest('.widget-content').find('select.actionId-check').val();
                var quantity = $(this).closest('.widget-content').find('.quantity-check').val();
                $('#' + id).closest('div').find('.price-check-error').remove();
                ShowLoader();
                $.ajax({
                    url: "@Url.Action(MVC.Receipt.CheckMinimumPrice())" + "?Price=" + price + "&Quantity=" + quantity + "&ActionID=" + actionId,
                    type: "GET",
                    contentType: "application/json",
                    async: true,
                    success: function (res) {
                        HideLoader();
                        if (res != null) {
                            if (res.IsBottomPrice) {
                                $('#' + id).css('border-color', 'orange');
                                $('<span class="price-check-error" style="color:orange">' + res.Message + '</span>').insertAfter('#' + id);
                            } else {
                                $('#' + id).css('border-color', '#ccc');
                            }
                        }
                    },
                    error: function (ex, msg, detail) {
                        console.log(ex);
                        alert("error : " + detail);
                        HideLoader();
                    }
                });
            });
        });

        var frm = $('#formAddReceipt');
        var strAlert = '';
        frm.submit(function (ev) {
            ShowLoader();
            $.ajax({
                type: frm.attr('method'),
                url: frm.attr('action'),
                data: frm.serialize(),
                success: function (data) {
                    HideLoader();
                    strAlert += data.Message;
                    alert(ParseDom(strAlert));
                    if (data.IsSuccess) {
                        window.location.href = "@Url.Action(MVC.Receipt.Index())";
                    }
                }
            });

            strAlert = '';
            ev.preventDefault();
        });

    var frmReject = $('#formRejectReceipt');
    function RejectDocument() {
        ShowLoader();
        $.ajax({
            type: frmReject.attr('method'),
            url: frmReject.attr('action'),
            data: frmReject.serialize(),
            success: function (data) {
                strAlert = "";
                HideLoader();
                strAlert += data.Message;
                alert(ParseDom(strAlert));
                if (data.IsSuccess) {
                    window.location.href = "@Url.Action(MVC.Receipt.Index())";
                }
            }
        });
    }
    </script>
    <style>
        .slickiiii {
            width: 240px;
        }

            .slickiiii .item {
                width: 100px;
                height: 150px;
                margin: 2px 5px;
            }

                .slickiiii .item img {
                    max-width: 100%;
                    min-width: 100%;
                    max-height: 100%;
                    min-height: 100%;
                    object-fit: cover;
                }

            .slickiiii .slick-prev, .slickiiii .slick-next {
                background: #808080;
                height: 50px;
            }

            .slickiiii .slick-disabled {
                opacity: 0.4;
            }
    </style>
}

